// import PDFDocument from 'pdfkit';

// const titleFontSize = 25;
// const subTitleFontSize = 14;
// const leadingFontSize = 12;
// const contentFontSize = 10;
// const paperSizeHeight = 841.89;
// const paperSizeWidth = 595.28;
// const paperMargin = 30;
// const lineSpacing = 15;
// const bottomGap = 20; // Adjust as needed for spacing between sections

// export async function createMasterInvoice(invoice) {
//   let doc = new PDFDocument({
//     size: [paperSizeWidth, paperSizeHeight],
//     margin: paperMargin,
//   });

//   generateHeader(doc, invoice, 50);
//   await generateOrderInformation(doc, invoice, 180);
//   generateInvoiceTable(doc, invoice, 320);
//   generateFooter(doc);
//   return doc;
// }

// function generateHeader(doc, invoice, customerInformationTop) {
//     const leftColumnX = paperMargin;
//     const rightColumnX = paperSizeWidth - paperMargin - 150; // Adjusted for right alignment

//     doc
//       .fillColor('#444444')
//       .fontSize(titleFontSize)
//       .font('Helvetica-Bold')
//       .text('Invoice', { align: 'center' })
//       .fontSize(subTitleFontSize)
//       .font('Helvetica');

//     // Left side - Company info
//     doc
//       .fontSize(leadingFontSize)
//       .font('Helvetica-Bold')
//       .text(
//         invoice.invoiceNumber,
//         leftColumnX,
//         customerInformationTop + lineSpacing * 3,
//       )
//       .fontSize(contentFontSize)
//       .font('Helvetica-Bold')
//       .text(
//         'Webapps Software Soluitons',
//         leftColumnX,
//         customerInformationTop + lineSpacing * 4,
//       )
//       .font('Helvetica')
//       .text(
//         '128, Jodhpur Gardens, Lake Gardens, Kolkata, West Bengal 700045',
//         leftColumnX,
//         customerInformationTop + lineSpacing * 5,
//       )
//       .text(
//         `GST Number: 19CRLPP7937D1Z7`,
//         leftColumnX,
//         customerInformationTop + lineSpacing * 6,
//       );

//     // Right side - Client Info
//     doc
//       .fontSize(contentFontSize)
//       .font('Helvetica-Bold')
//       .text(
//         'Bill to:',
//         rightColumnX,
//         customerInformationTop + lineSpacing * 3,
//       )
//       .font('Helvetica')
//       .text(
//         invoice.businessName || invoice?.business?.personName,
//         rightColumnX,
//         customerInformationTop + lineSpacing * 4,
//       )
//       .text(
//         `GST No.: ${invoice?.business?.gstNo || 'N/A'}`,
//         rightColumnX,
//         customerInformationTop + lineSpacing * 5,
//       );

//     doc.moveDown(); // Add space after the section
//   }

// async function generateOrderInformation(doc, invoice, customerInformationTop) {
//   const leftColumnX = paperMargin;
//   const rightColumnX = paperSizeWidth - paperMargin - 350; // Adjusted to fit the content on the right side

//   // Right column text
//   doc
//     .fontSize(contentFontSize)
//     .font('Helvetica-Bold')
//     .text(
//       `Invoice Date: ${invoice.paymentDate}`,
//       rightColumnX,
//       customerInformationTop,
//       { align: 'right' },
//     )
//     .text(
//       `Sale Agent: Webapps Software Solutions`,
//       rightColumnX,
//       customerInformationTop + lineSpacing,
//       { align: 'right' },
//     )
//     .text(
//       `Subject: ${invoice.subject}`,
//       rightColumnX,
//       customerInformationTop + lineSpacing * 2,
//       { align: 'right' },
//     );

//   //   generateHr(doc, customerInformationTop + lineSpacing * 4 + bottomGap);
// }

// function generateInvoiceTable(doc, invoice, y) {
//   doc.font('Helvetica-Bold');
//   generateTableRow(doc, y, 'Item', 'Qty', 'Tax', 'Amount', true);
//   generateHr(doc, y + lineSpacing);
//   doc.font('Helvetica');

//   let position = y + 30;
//   generateTableRow(
//     doc,
//     position,
//     invoice.subject,
//     '1',
//     '',
//     invoice.subTotal.toFixed(2),
//   );
//   // generateHr(doc, position + 18);

//   let taxPosition = position + 30;
//   invoice.tax.forEach((tax, index) => {
//     generateTableRow(
//       doc,
//       taxPosition + index * lineSpacing,
//       '',
//       '',
//       `${tax.taxName}: ${tax.rate}`,
//       ((invoice.subTotal * parseInt(tax.rate)) / 100).toFixed(2),
//     );
//   });
//   taxPosition += invoice.tax.length * lineSpacing;

//   const subtotalPosition = 450;
//   generateTableTotal(
//     doc,
//     subtotalPosition,
//     'Sub Total:',
//     formatCurrency(invoice.subTotal.toFixed(2)),
//   );
//   const totalPosition = subtotalPosition + lineSpacing;
//   generateTableTotal(
//     doc,
//     totalPosition,
//     'Total:',
//     formatCurrency(invoice.total),
//   );
//   const totalPaidPosition = totalPosition + lineSpacing;
//   generateTableTotal(
//     doc,
//     totalPaidPosition,
//     'Total Paid:',
//     formatCurrency(invoice.paid),
//   );
//   const duePosition = totalPaidPosition + lineSpacing;
//   generateTableTotal(
//     doc,
//     duePosition,
//     'Amount Due:',
//     formatCurrency(invoice.amountDue),
//   );
// }

// function generateTableRow(doc, y, item, qty, tax, amount, isHeader = false) {
//   const fontStyle = isHeader ? 'Helvetica-Bold' : 'Helvetica';
//   doc
//     .fontSize(contentFontSize)
//     .font(fontStyle)
//     .text(item, paperMargin, y, { width: 180 }) // Adjust width
//     .text(qty, paperMargin + 200, y, { width: 80, align: 'center' })
//     .text(tax, paperMargin + 280, y, { width: 100, align: 'center' })
//     .text(amount, paperMargin + 400, y, { width: 80, align: 'right' });
// }

// function generateTableTotal(doc, y, title, total) {
//   doc
//     .fontSize(contentFontSize)
//     .text(title, 50, y, { width: 450, align: 'right' })
//     .text(total, 530, y, { width: 50, align: 'left' });
// }

// function generateFooter(doc) {
//   const footerText =
//     'This is a computer-generated invoice and requires no signature or stamp.';
//   const footerHeight = 20; // Adjust as needed for footer height
//   const footerY = doc.page.height - doc.page.margins.bottom - footerHeight;

//   doc.fontSize(10).text(footerText, doc.page.margins.left, footerY, {
//     width: doc.page.width - doc.page.margins.left - doc.page.margins.right,
//     align: 'center',
//   });
// }

// function formatCurrency(amount) {
//   return parseFloat(amount).toFixed(1);
// }

// function formatDate(date) {
//   const day = date.getDate();
//   const month = date.getMonth() + 1;
//   const year = date.getFullYear();

//   return year + '/' + month + '/' + day;
// }

// function generateHr(doc, y) {
//   doc
//     .strokeColor('#aaaaaa')
//     .lineWidth(1)
//     .moveTo(paperMargin, y)
//     .lineTo(paperSizeWidth - paperMargin, y)
//     .stroke();
// }

import PDFDocument from 'pdfkit';

const titleFontSize = 24;
const subTitleFontSize = 14;
const leadingFontSize = 13;
const contentFontSize = 11;
const tableHeaderFontSize = 12;
const footerFontSize = 10;

const paperSizeHeight = 841.89;
const paperSizeWidth = 595.28;
const paperMargin = 40;
const lineSpacing = 18;
const bottomGap = 25;

export async function createMasterInvoice(invoice) {
  let doc = new PDFDocument({
    size: [paperSizeWidth, paperSizeHeight],
    margin: paperMargin,
  });

  generateHeader(doc, invoice, 60);
  await generateOrderInformation(doc, invoice, 180);
  generateInvoiceTable(doc, invoice, 330);
  generateFooter(doc);
  return doc;
}

function generateHeader(doc, invoice, top) {
  const leftX = paperMargin;
  const rightX = paperSizeWidth - paperMargin - 150;

  doc
    .fillColor('#2c3e50')
    .fontSize(titleFontSize)
    .font('Helvetica-Bold')
    .text('INVOICE', { align: 'center' })
    .moveDown(0.5)
    .fontSize(subTitleFontSize)
    .font('Helvetica')
    .fillColor('#000');

  // Left Column - Company Info
  doc
    .fontSize(leadingFontSize)
    .font('Helvetica-Bold')
    .fillColor('blue') 
    .text(invoice.invoiceNumber, leftX, top + lineSpacing * 2)
    .fillColor('black') 
    .text('Webapps Software Solutions', leftX, top + lineSpacing * 3)
    .font('Helvetica')
    .text('128, Jodhpur Gardens, Lake Gardens,', leftX, top + lineSpacing * 4)
    .text('Kolkata, West Bengal 700045', leftX, top + lineSpacing * 5)
    .text('GST Number: 19CRLPP7937D1Z7', leftX, top + lineSpacing * 6);

  // Right Column - Client Info
  doc
    .fontSize(contentFontSize)
    .font('Helvetica-Bold')
    .fillColor('red') 
    .text('Bill To:', rightX, top + lineSpacing * 2)
    .fillColor('black') 
    .font('Helvetica-Bold')
    .text(
      invoice.businessName || invoice?.business?.personName,
      rightX,
      top + lineSpacing * 3,
    )
    .font('Helvetica')
    .text(
      `GST No.: ${invoice?.business?.gstNo || 'N/A'}`,
      rightX,
      top + lineSpacing * 4,
    );
}

async function generateOrderInformation(doc, invoice, top) {
  const rightX = paperSizeWidth - paperMargin - 350;

  doc
    .fontSize(contentFontSize)
    .font('Helvetica-Bold')
    .text(`Invoice Date: ${invoice.paymentDate}`, rightX, top, {
      align: 'right',
    })
    .text(
      `Sales Agent: Webapps Software Solutions`,
      rightX,
      top + lineSpacing,
      { align: 'right' },
    )
    .text(`Subject: ${invoice.subject}`, rightX, top + lineSpacing * 2, {
      align: 'right',
    });

  generateHr(doc, top + lineSpacing * 4 + bottomGap);
}

function generateInvoiceTable(doc, invoice, y) {
  doc.font('Helvetica-Bold').fontSize(tableHeaderFontSize);
  generateTableRow(doc, y, 'Item', 'Qty', 'Tax', 'Amount', true);
  generateHr(doc, y + lineSpacing);

  doc.font('Helvetica').fontSize(contentFontSize);
  let position = y + lineSpacing * 2;
  generateTableRow(
    doc,
    position,
    invoice.subject,
    '1',
    '',
    invoice.subTotal.toFixed(2),
  );

  let taxPosition = position + lineSpacing;
  invoice.tax.forEach((tax, index) => {
    generateTableRow(
      doc,
      taxPosition + index * lineSpacing,
      '',
      '',
      `${tax.taxName}: ${tax.rate}%`,
      ((invoice.subTotal * parseInt(tax.rate)) / 100).toFixed(2),
    );
  });

  taxPosition += invoice.tax.length * lineSpacing + 20;

  generateTableTotal(
    doc,
    taxPosition,
    'Sub Total:',
    formatCurrency(invoice.subTotal),
  );
  generateTableTotal(
    doc,
    taxPosition + lineSpacing,
    'Total:',
    formatCurrency(invoice.total),
    true,
  );
  generateTableTotal(
    doc,
    taxPosition + lineSpacing * 2,
    'Total Paid:',
    formatCurrency(invoice.paid),
  );
  generateTableTotal(
    doc,
    taxPosition + lineSpacing * 3,
    'Amount Due:',
    formatCurrency(invoice.amountDue),
    true,
  );
}

function generateTableRow(doc, y, item, qty, tax, amount, isHeader = false) {
  const fontStyle = isHeader ? 'Helvetica-Bold' : 'Helvetica';
  const fontSize = isHeader ? tableHeaderFontSize : contentFontSize;

  doc
    .font(fontStyle)
    .fontSize(fontSize)
    .text(item, paperMargin, y, { width: 180 })
    .text(qty, paperMargin + 200, y, { width: 80, align: 'center' })
    .text(tax, paperMargin + 300, y, { width: 100, align: 'center' })
    .text(amount, paperMargin + 430, y, { width: 80, align: 'right' });
}

function generateTableTotal(doc, y, title, total, emphasize = false) {
  doc
    .fontSize(contentFontSize)
    .font(emphasize ? 'Helvetica-Bold' : 'Helvetica')
    .text(title, 300, y, { width: 200, align: 'right' })
    .text(total, 510, y, { width: 60, align: 'right' });
}

function generateFooter(doc) {
  const footerText =
    'This is a computer-generated invoice and requires no signature or stamp.';
  const footerY = doc.page.height - doc.page.margins.bottom - 30;

  doc
    .fontSize(footerFontSize)
    .fillColor('#555')
    .text(footerText, doc.page.margins.left, footerY, {
      width: doc.page.width - doc.page.margins.left - doc.page.margins.right,
      align: 'center',
    });
}

function formatCurrency(amount) {
  return `${parseFloat(amount).toFixed(2)}`;
}

function generateHr(doc, y) {
  doc
    .strokeColor('#cccccc')
    .lineWidth(1)
    .moveTo(paperMargin, y)
    .lineTo(paperSizeWidth - paperMargin, y)
    .stroke();
}
